package cz.zcu.kiv.cosi.parkoviste.parkoviste;

import java.util.HashMap;

import org.osgi.service.event.Event;
import org.osgi.service.event.EventAdmin;

import cz.zcu.kiv.cosi.parkoviste.konfigurace.IKonfigurace;

public class Parkoviste implements IPrijezdyOdjezdy {
	private EventAdmin messageService;
	
	private static final int MISTA_AUTO = 1;
	private static final int MISTA_BUS = 2;
	private static final int MISTA_TIR = 4;
	
	private int kapacita;
	private int volnaMista;
	
	private int pocetAuta;
	private int pocetBus;
	private int pocetTir;
	
	public synchronized void setMessageService(EventAdmin messageService) {
		this.messageService = messageService;
	}
	
	public synchronized void setKapacita(IKonfigurace konfigurace) {
		this.kapacita = konfigurace.getKapacita();
		this.volnaMista = kapacita;
	}
	
	public Parkoviste( ){	
		System.out.println("Parkoviste created...");
		this.pocetAuta = 0;
		this.pocetBus = 0;
		this.pocetTir = 0;	
	}
	
	private void posliZpravuMista(){
		HashMap<String, Integer> hm = new HashMap<String, Integer>();
		hm.put("volnaMista", volnaMista);
		if(volnaMista == 0){
			posliZpravuPlno();
		}
		messageService.sendEvent(new Event("parkoviste/zbyva", hm));
	}
	
	private void posliZpravuPlno(){
		messageService.postEvent(new Event("parkoviste/plne", new HashMap<String, Integer>()));
	}
	
	@Override
	public void odjelBus() throws Exception {
		if(((volnaMista + MISTA_BUS) <= kapacita) && pocetBus > 0){
			volnaMista += MISTA_BUS;
			
			pocetBus--;
			posliZpravuMista();
		}else{
			throw new Exception("Neni bus k odjezdu!");
		}
	}

	@Override
	public void odjelTir() throws Exception {
		if(((volnaMista + MISTA_TIR) <= kapacita) && pocetTir > 0){
			volnaMista += MISTA_TIR;
			
			pocetTir--;
			posliZpravuMista();
		}else{
			throw new Exception("Neni tir k odjezdu!");
		}
	}

	@Override
	public void odjeloAuto() throws Exception {
		if(((volnaMista + MISTA_AUTO) <= kapacita) && pocetAuta > 0){
			volnaMista += MISTA_AUTO;
			
			pocetAuta--;
			posliZpravuMista();
		}else{
			throw new Exception("Neni auto k odjezdu!");
		}
	}

	@Override
	public void prijelBus() throws Exception {
		if((volnaMista - MISTA_BUS) >= 0){
			volnaMista -= MISTA_BUS;
			
			pocetBus++;
			posliZpravuMista();
		}else{
			
			if(volnaMista == 0){
				posliZpravuMista();
			}
			
			throw new Exception("Nedostatek mist pro bus!");
		}
	}

	@Override
	public void prijelTir() throws Exception {
		if((volnaMista - MISTA_TIR) >= 0){
			volnaMista -= MISTA_TIR;
			
			pocetTir++;
			posliZpravuMista();
		}else{
			
			if(volnaMista == 0){
				posliZpravuMista();
			}
			
			throw new Exception("Nedostatek mist pro tir!");
		}
	}

	@Override
	public void prijeloAuto() throws Exception{
		if((volnaMista - MISTA_AUTO) >= 0){
			volnaMista -= MISTA_AUTO;
			
			pocetAuta++;
			posliZpravuMista();
		}else{
			
			posliZpravuMista();
			throw new Exception("Nedostatek mist pro auto!");
		}
	}

}
