package cz.zcu.kiv.cosi.parkoviste.pult;

import org.osgi.service.component.ComponentContext;
import org.osgi.service.event.Event;
import org.osgi.service.event.EventHandler;

import cz.zcu.kiv.cosi.parkoviste.brana.IPrijeloOdjelo;
import cz.zcu.kiv.cosi.parkoviste.konfigurace.IZapVyp;

public class Pult implements EventHandler {
	
	private IZapVyp tabule;

	private IZapVyp brana;
	
	private IPrijeloOdjelo statistika;
	
	private int pracovniDoba = 15000;

	public synchronized void setTabule(IZapVyp tabule) {
		this.tabule = tabule;
	}
	
	public synchronized void setBrana(IZapVyp brana) {
		this.brana = brana;
	}
	
	public synchronized void setStatistika(IPrijeloOdjelo statistika) {
		this.statistika = statistika;
	}

	private void println(String output) {
		System.out.println("Pult: " + output);
	}
	
	public void zacatek() {
		println("Pracovni doba zacala, spoustim tabuli a branu...");
		tabule.zap();
		brana.zap();
	}
	
	public void konec() {
		println("Pracovni doba konci, vypinam tabuli a branu...");
		tabule.vyp();
		brana.vyp();
		System.out.println("Na parkovisti zustalo: " + (statistika.getPrijelo() - statistika.getOdjelo()) + " vozidel...");
	}
	
	protected void activate(ComponentContext context) {
		System.out.println("Pult created...");
		while (true) {
			zacatek();
			try {
				Thread.sleep(pracovniDoba);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			konec();		
		}
	}

	@Override
	public void handleEvent(Event event) {
		if ("parkoviste/zbyva".equals(event.getTopic()))
			println("Zbyva mist : " + event.getProperty("volnaMista"));
		else
			println("Parkoviste plne!");
	}
}
